import os  # Importing the os module for file and directory operations
from cryptography.fernet import Fernet  # Importing Fernet class for symmetric encryption

# Function to decrypt an encrypted file
def decrypt_file(encrypted_file_path, key):
    fernet = Fernet(key)  # Initializing Fernet with the provided key

    # Reading the encrypted data from the file
    with open(encrypted_file_path, 'rb') as encrypted_file:
        encrypted_data = encrypted_file.read()

    # Decrypting the data using the Fernet instance
    decrypted_data = fernet.decrypt(encrypted_data)

    # Generating the path for the decrypted file by removing the '.encrypted' extension
    decrypted_file_path = encrypted_file_path.replace('.encrypted', '')

    # Writing the decrypted data to a new file
    with open(decrypted_file_path, 'wb') as decrypted_file:
        decrypted_file.write(decrypted_data)

    # Removing the encrypted file after decryption
    os.remove(encrypted_file_path)

    print(f'File decrypted to: {decrypted_file_path}')
    return decrypted_file_path

# Function to decrypt all files in a folder
def decrypt_folder(encrypted_folder_path, key):
    # Walking through all files in the encrypted folder
    for root, _, files in os.walk(encrypted_folder_path):
        for file in files:
            # Constructing the full path for each encrypted file
            encrypted_file_path = os.path.join(root, file)
            decrypt_file(encrypted_file_path, key)  # Decrypting each file

    print(f'All files in folder {encrypted_folder_path} decrypted.')
    return encrypted_folder_path

# Path to the folder containing encrypted files
encrypted_folder_path = r'Sample'
# Symmetric encryption key
key = b'iGN5XGf28DYoqHqmu6k5m17LEoEJj0MDx4gtKFAKPRg='

# Decrypting the folder and getting the path to the decrypted folder
decrypt_folder(encrypted_folder_path, key)